(define-module (ui net-bond ajax)
	:use-module (alterator str)
	:use-module (alterator ajax)
	:use-module (alterator woo)
	:use-module (alterator algo)
	:export (init))

(define *iface* (make-cell ""))

(define (ui-update-lists bond)
  (catch/message
	(lambda()
	  (form-update-enum "bonded_ifaces" (woo-list "/net-bond/bonded_ifaces" 'bond bond))
	  (form-update-enum "avail_ifaces" (woo-list "/net-bond/avail_ifaces")))))

(define (init-bond-name)
  (let ((fname (form-value "iface")))
	(if (or (not fname)
			(empty-string? fname))
	  (woo-get-option (woo-read-first "/net-bond/new_name") 'new_name)
	  fname)))

(define (ui-read bond)
  (cell-set! *iface* bond)
  (form-update-value "iface" bond)
  (catch/message
	(lambda()
	  (let ((cmd (woo-read-first "/net-bond" 'bond bond)))
		(ui-update-lists bond)
		(form-update-value-list '("mode" "bond_options") cmd)))))

(define (add-iface)
  (let* ((bond (cell-ref *iface*))
		(name (or (form-value "avail_ifaces") "")))
	(catch/message
	  (lambda()
		(woo-write "/net-bond/add_iface" 'language (form-value "language") 'bond bond 'name name)))
	(ui-update-lists bond)))


(define (del-iface)
  (let ((bond (cell-ref *iface*))
		(name (or (form-value "bonded_ifaces") "")))
	(catch/message
	  (lambda()
		(woo-write "/net-bond/del_iface" 'language (form-value "language") 'bond bond 'name name)))
	(ui-update-lists bond)))

(define (ui-write)
   (catch/message
	 (lambda()
	   (woo-write "/net-bond" 'language (form-value "language")
				  'bond (cell-ref *iface*)
				  'bond_options (form-value "bond_options")
				  'mode (form-value "mode")))))

(define (ui-exit)
  (ui-write)
  (form-replace (format #f "/net-eth?iface=~A" (cell-ref *iface*))))

(define (init)
  (ui-read (init-bond-name))
  (form-bind "add_iface_btn" "click" add-iface)
  (form-bind "del_iface_btn" "click" del-iface)
  (form-bind "back" "click" ui-exit))
